#include <QCoreApplication>
#include "autologin.h"
#include "vmdaemon_interface.h"
#include <QEventLoop>
#include <QTimer>
AutoLogin::AutoLogin(const QString &username,
                     const QString &password,
                     const QString &token):
    m_username(username), m_password(password),m_token(token)
{
    QTimer::singleShot(0, this, [=]{
        QStringList list = m_username.split(QStringLiteral("@"));
        if (list.size() == 2 && !list.at(1).isEmpty())
        {
            QString realm_name = list.at(1);
            if(realm_name == QStringLiteral("zte"))
            {
                m_username = m_username.append(QStringLiteral(".intra"));
            }
        }
        if(!m_username.isEmpty() && !m_username.contains("@"))
        {
            m_username.append("@zte.intra");
        }
        while(true)
        {
            com::vm::daemon daemonInterface("com.vm.daemon",
                                            "/daemon",QDBusConnection::systemBus(), this);

            if(daemonInterface.isValid() &&
                    daemonInterface.setUser(m_username, m_password, m_token))
            {
                emit exit();
                break;
            }
            QEventLoop eventloop;
            QTimer::singleShot(1000, &eventloop, SLOT(quit()));
            eventloop.exec();
        }
    });
}
