#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <pthread.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <utility>
#include <string>
#include <signal.h>
#include <fcntl.h>
#include <ctype.h>
#include <termios.h>
#include <sys/mman.h>
#include <sys/time.h>



using namespace std;

#define MAXLINE 1024


struct uds_data
{
    char input[MAXLINE];
    char output[MAXLINE];
    char udstoken[MAXLINE];
};


//调用系统命令，并获取输出（相当于使用system）
//input: 要调用的系统命令
//output: 调用命令后系统的输出
//maxlen: 输出字符串的最大长度
int oscmd(char *input, char *output, int maxlen)
{
    if( nullptr==input || nullptr==output )
        return -1;
    int reslen;
    FILE *stream;
    memset(output, 0, maxlen);
    //创建管道，并将input里的内容写入管道
    stream = popen(input, "r");
    //从管理中读出数据，并写入output数组
    reslen = fread(output, sizeof(char), maxlen, stream);
    pclose(stream);
    return reslen;
}

//令牌字符串是隔段时间会变的，因此需要循环判断令牌是否改变
void * Token_run(void *data)
{
    int ret = 0;
    srand((unsigned int)time(nullptr));
    struct uds_data *uds_cmd = (struct uds_data*)data;
    while(1)
    {
        ret = rand()%2400;
        oscmd(uds_cmd->input, uds_cmd->output, MAXLINE);
        if(strcmp(uds_cmd->output,uds_cmd->udstoken) != 0)
        {
            strcpy(uds_cmd->udstoken, uds_cmd->output);
        }
        sleep(3600+ret);
    }
}


int Token_server(char *token){

    unlink("/tmp/sock_UDS");

    struct sockaddr_un server_addr;
    struct sockaddr_un client_addr;

    int server_sock,client_sock;

    server_sock = socket(PF_UNIX,SOCK_STREAM,0);//创建服务器套接字
    if(-1==server_sock){
        perror("server_sock created failed");
        return -1;
    }

    memset(&server_addr,0,sizeof(server_addr));
    server_addr.sun_family = PF_UNIX;
    strcpy(server_addr.sun_path,"/tmp/sock_UDS");

    if(-1==bind(server_sock,(struct sockaddr*)&server_addr,sizeof(server_addr))){
        perror("bind failed");
        return -1;
    }

    if(-1==listen(server_sock,3)){
        perror("listen failed");
        return -1;
    }

    socklen_t client_addr_len = sizeof(client_addr);

    char *recv_buffer = new char[MAXLINE];
    int send_len;
    while(true){
        client_sock = accept(server_sock,(struct sockaddr * )&client_addr,&client_addr_len);
        if(-1==client_sock){
            perror("accept failed");
            return -1;
        }
        send_len = send(client_sock,token,MAXLINE,0);
        close(client_sock);
    }
    delete [] recv_buffer;
}


int main()
{
    struct uds_data uds_d;
    static char recv_name[1024]={0};
    static char recv_pass[1024]={0};

    /*监听客户端发送过来的用户名及密码*/
    struct sockaddr_in sockaddr;
    sockaddr.sin_family=AF_INET;
    sockaddr.sin_port=htons(5188);
    sockaddr.sin_addr.s_addr=htonl(INADDR_ANY);
    int sockid=socket(AF_INET,SOCK_STREAM,0);
    const int on=1;
    if(setsockopt(sockid,SOL_SOCKET,SO_REUSEADDR,&on,sizeof(on))<0)
    {
        printf("setsockopt\n");
        return 0;
    }
    if(bind(sockid,(struct sockaddr *)&sockaddr,sizeof(sockaddr))<0)
    {
        printf("bind\n");
        return 0;
    }
    if(listen(sockid,SOMAXCONN)<0)
    {
        printf("listen\n");
        return 0;
    }
    struct sockaddr_in other_sock_addr;
    socklen_t other_sock_addr_len=sizeof(other_sock_addr);
    int client_sockid=0;
    client_sockid=accept(sockid,(struct sockaddr *)&other_sock_addr,&other_sock_addr_len);
    if(client_sockid<0)
    {
        printf("accept\n");
        return 0;
    }

    read(client_sockid,recv_name,sizeof(recv_name));
    read(client_sockid,recv_pass,sizeof(recv_pass));
    close(sockid);
    close(client_sockid);
    /*监听end*/


    char uds_login_cmd[1024];

    strcpy(uds_login_cmd, "curl --ntlm -u ");
    strcat(uds_login_cmd, recv_name);
    strcat(uds_login_cmd, ":");
    strcat(uds_login_cmd, recv_pass);
    strcat(uds_login_cmd, " http://printsrv.zte.com.cn/UDS/ClientTokenInfo.ashx");
    strcpy(uds_d.input, uds_login_cmd);

    //申明一个本地变量tid，用来保存对等线程的ID
    pthread_t tid;
    //调用pthread_create函数创建一个新的线程，
    pthread_create(&tid, nullptr, Token_run, (void *)&uds_d);
    //监听客户端，发送UDS令牌给客户端
    Token_server(uds_d.udstoken);

    return 0;
}

