#ifndef VMDAEMON_H
#define VMDAEMON_H

#include <QObject>

class QProcess;
class UACVerify;
class VMDaemon : public QObject
{
    Q_OBJECT
public:
    explicit VMDaemon(QObject *parent = nullptr);
signals:
    void finished(int exitCode, const QString &message);
    void autoLogin();
    void tokenSuccess();
public slots:
    void start();
    QString password();
    bool setUser(const QString &userName, const QString &password, const QString &token);
    void deleteCommonUser();
    QString userName();
    bool isAdded();
    void initStatus();
    bool isZte();
    bool ping();
private:
    void startDomain();
    QProcess *mProcess;
    int mCount;
    QString mUserName;
    QString mPassword;
    QString mToken;
    UACVerify *mUacVeriy;
};

#endif // VMDAEMON_H
